/*
 *	app.h
 *
 *	P/ECEAvP[V̐^iCLiPCuŁj
 *
 *	* Tue Jul 23 21:01:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __APP_H__
#define __APP_H__

#include <clip.h>

/****************************************************************************
 *	
 ****************************************************************************/

//#define V_SCREEN /* cʃ[hgꍇ́ÃV{`Ă */
#ifdef V_SCREEN
#undef DISP_X
#undef DISP_Y
#define DISP_X	 88
#define DISP_Y	128
#endif /*V_SCREEN*/

#define USE_MUSIC /* yCugꍇ́ÃV{`Ă */
#ifdef USE_MUSIC
#define music_play(data) do { music_stop(); PlayMusic((unsigned char*)(data)); } while(0)
#define music_stop() do { StopMusic(); sound_stop(music_wch); } while(0)
#else /*USE_MUSIC*/
#define music_play(data) ((void)0)
#define music_stop() ((void)0)
#endif /*USE_MUSIC*/

#define USE_SPRITE /* ȈՃXvCghCogꍇ́ÃV{`Ă */
#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT1
enum {
#include "sprite.h"
	SPRITE_COUNT
};
extern const SPRITE sprite_table[SPRITE_COUNT];
#undef SPRITE_
#endif /*USE_SPRITE*/

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
#define QUICK_REPEAT
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
#define QUICK_REPEAT_DELAY	SEC(0.25)

/****************************************************************************
 *	
 ****************************************************************************/

#define FPS	20				/* t[[g */
#define SEC(s)	((int)(FPS * (s)))		/* b->t[ϊ */

#define TEXTURE_LIST	PAT,BG,RDY1,RDY2	/* eNX`Xg */
#define TEXTURE_COUNT	4			/* eNX`̐ */

typedef struct _CELL {
	short virus;		/* 0:/1`:aۂ̎ */
	short state;		/* 0:ʏ/1`:CELL_STATE_* */
	short substate;		/* ⏕ */
	short counter;		/* JE^ */
} CELL;

/* CELL.virus */
#define CELL_VIRUS_TEL		(1 + 4)	/* db̎ޔԍ */

/* CELL.state */
#define CELL_STATE_MOVEDN	1	/* ړ */
#define CELL_STATE_MOVELF	2	/* ړ */
#define CELL_STATE_MOVERI	3	/* Eړ */
#define CELL_STATE_FALL		4	/*  */
#define CELL_STATE_CHECK	5	/* ړorAŔ҂ */
#define CELL_STATE_ERASE	6	/*  */
#define CELL_STATE_RAISE	7	/* (GameOver) */
#define CELL_STATE_COUNT	8	/* ZԂ̐Bcount_cell_state()֐Ŏg܂B */

#define FIELD_INNER_COLS	8				/* tB[hŽ */
#define FIELD_INNER_ROWS	9				/* tB[hZ̍s */
#define FIELD_COLS		(1 + FIELD_INNER_COLS + 1)	/* OZ܂ށAtB[hŜ̌ */
#define FIELD_ROWS		(1 + FIELD_INNER_ROWS + 1)	/* OZ܂ށAtB[hŜ̍s */
#define FIELD_COL_MIN		0				/* OZ܂ށAtB[h̍ŏ */
#define FIELD_COL_MAX		(FIELD_COLS - 1)		/* OZ܂ށAtB[h̍ő包 */
#define FIELD_ROW_MIN		0				/* OZ܂ށAtB[h̍ŏs */
#define FIELD_ROW_MAX		(FIELD_ROWS - 1)		/* OZ܂ށAtB[h̍ős */
#define FIELD_INNER_COL_MIN	(FIELD_COL_MIN + 1)		/* Ẑ݂́AtB[h̍ŏ */
#define FIELD_INNER_COL_MAX	(FIELD_COL_MAX - 1)		/* Ẑ݂́AtB[h̍ő包 */
#define FIELD_INNER_ROW_MIN	(FIELD_ROW_MIN + 1)		/* Ẑ݂́AtB[h̍ŏs */
#define FIELD_INNER_ROW_MAX	(FIELD_ROW_MAX - 1)		/* Ẑ݂́AtB[h̍ős */

#define PLAYER_COL_MIN		(FIELD_INNER_COL_MIN - 1)	/* vC[ړ\ȍŏ */
#define PLAYER_COL_MAX		(FIELD_INNER_COL_MAX + 1)	/* vC[ړ\ȍő包 */

#define MAX_SCORE		9999999				/* őXRA */

/* Q[ZbV̍\̂łB */
typedef struct _GAME {
	int score;			/* XRA */
	int level;			/* x */
	int level_start_time;		/* ݂̃x̊Jn */
	int show_level;			/* x\H(B@\) */
	int start_count;		/* READY`GO̎c\ */

	int generic_seed;		/* ėpV[h */
	int virus_seed;			/* a̐pV[h */
	int tel_remain;			/* db͂܂Ƃ߂ĎOoB̎c萔 */
	int load_timer;			/* 񃍁[h܂ł̃JEg_E^C} */
	int force_load;			/* [h1 */

	int erase_in_progress;		/* 1ANVł̏ŘAȂ1 */
	int erase_chain;		/* AJE^Bł1AƐB */
	int shot_count;			/* ȌŊȍ~̃Vbg񐔁BiU͐Ȃj */
					/* 0or1̃VbgōĂяŊJnAApƌȂB */

	/*** vC[ ***/
	int player_state;		/* 0:ʏ/1`:PLAYER_STATE_* */
	int player_substate;		/* ⏕ */
	int player_counter;		/* JE^ */
	int player_col;			/* ʒu[Z] */
	int player_row;			/* cʒu[Z] */

	CELL field[FIELD_ROWS][FIELD_COLS];	/* tB[h */
} GAME;

/* GAME.player_state */
#define PLAYER_STATE_SHOTDN	1	/* ˂ */
#define PLAYER_STATE_SHOTLF	2	/* ˂ */
#define PLAYER_STATE_SHOTRI	3	/* E˂ */
#define PLAYER_STATE_CLEANUP	4	/* N[Abv */
#define PLAYER_STATE_MISS	5	/* ~X */
#define PLAYER_STATE_FALL	6	/*  */

#define LOAD_DELAY	SEC(0.5)	/* [h\`܂ł̒x */

/* xe[u̍\̂łB */
typedef struct _LEVEL {
	int virus_kinds;		/* â̎ސ (1`4Bdb͊܂܂Ȃ) */
	int load_count;			/* [h񓖂̕a̐ */
	int load_interval;		/* [hԊu */
	int tel_rate;			/* dbom (N/10000) */
	int level_keep_time;		/* ̃x̌p */
} LEVEL;
extern const LEVEL level_table[];	/* xe[u */

/* difficulty */
#define DIFFICULTY_NORMAL	0
#define DIFFICULTY_HARD		1
#define DIFFICULTY_VERYHARD	2

/* aۃp^[e[u */
typedef struct VIRUSPATTERN {
	int normal;			/* ʏA]AŮXvCgԍ */
	int action;			/* ł̊XvCgԍ */
} VIRUSPATTERN;
const VIRUSPATTERN virus_pattern_table[5/*aۂ̎*/];

/*** ʃCAEg ***/
#define CELL_W		14					/* ZTCY[sNZ] */
#define CELL_H		8
#define FIELD_X0	((DISP_X - CELL_W * FIELD_COLS) / 2)	/* tB[h_[sNZ] */
#define FIELD_Y0	((DISP_Y - CELL_H * FIELD_ROWS) / 2 - 1)

/*** ʉ ***/
#define CH_PLAYER	1	/* vC[ʉ`l */
#define CH_FIELD	2	/* tB[hʉ`l */
#define CH_TEL		3	/* dbʉp`l */
extern const unsigned char SND_PMOV[];
extern const unsigned char SND_PSH1[];
extern const unsigned char SND_PSH2[];
extern const unsigned char SND_PFAL[];
extern const unsigned char SND_CTEL[];
extern const unsigned char SND_CGEN[];
extern const unsigned char SND_CRAI[];
extern const unsigned char SND_CER1[];
extern const unsigned char SND_CER2[];
extern const unsigned char SND_CER3[];
extern const unsigned char SND_CER4[];
extern const unsigned char SND_CER5[];
extern const unsigned char SND_CER6[];
extern const unsigned char SND_CER7[];
extern const unsigned char SND_CER8[];

void app_init();
void app_exit();
void schedule();
int demo_main();
int new_virus();
void gen_virus();
void game_start();
void start_disp();
void game_init();
void round_init();
void game_main();
void set_player_state(int player_state);
void set_player_substate(int player_substate);
void set_cell_state(CELL* cell, int cell_state);
void set_cell_substate(CELL* cell, int cell_substate);
void clear_cell(CELL* cell);
void count_cell_state(int state_count[/*CELL_STATE_COUNT*/], int inner_only);
void bg_disp();
void player_disp();
void player_action(int action_ok);
void process_shot();
void field_disp();
void field_action_normal();
void field_check_fall();
void field_action_fall();
void field_check_erase();
void field_action_erase();
void field_check_raise();
void field_action_raise();
void chain_disp(int chain);
void cleanup_disp();
void overflow_disp(int count);
void score_disp();
void score_up(int pts);

/****************************************************************************
 *	
 ****************************************************************************/

#include "work.h"

#endif /*__APP_H__*/
