/*
 *	main.c
 *
 *	Kcǂ
 *
 *	* Mon May 24 2004 19:00:00 JST 2004 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

const unsigned char MUS_GAME[] = {
#include "mus_game.c"
};

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_MUSIC
#include "instdef2.c"
#endif /*USE_MUSIC*/

#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT2
const SPRITE sprite_table[SPRITE_COUNT] = {
#include "sprite.h"
};
#undef SPRITE_
#endif /*USE_SPRITE*/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo_main() < 0) break;
		game_main();
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(1/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef USE_MUSIC
	/* yCu܂B */
	music_loudness(1);
	loadInst(); /* uRandomism Zone(http://www8.plala.or.jp/randomism/)v́whFLbgver.2.10xgp */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* eNX`܂B */
#ifdef TEXTURE_LIST
	{
		typedef const unsigned char TEXTURE_DATA[];
		extern TEXTURE_DATA TEXTURE_LIST;
		texture_table_init(texture_table, sizeof texture_table / sizeof *texture_table, TEXTURE_LIST);
	}
#endif /*TEXTURE_LIST*/

#ifdef USE_SPRITE
	/* ȈՃXvCghCo܂B */
	sprite_init(&render, sprite_table, SPRITE_COUNT, texture_table, TEXTURE_COUNT);
#endif /*USE_SPRITE*/

/*{{AvP[VL̏*/
	//turbo(1); /* S48MHz[h */
	turbo(7); /* 48MHz/1WAIT */
	srand(pceTimerGetCount());
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
	music_loudness(0);
#endif /*USE_MUSIC*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
//#define PAUSE_COLOR	0x130		/* PAUSEJ[(wip) */
#define PAUSE_COLOR	0x203		/* PAUSEJ[(wip) */
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5 + 2)	/* PAUSEbZ[W̉ */
#define PAUSE_H		(10    + 2)	/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */

#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int pause, x, y;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
	now++;	/* O[o^C}XV */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT

#undef PAUSE_FONT
#undef PAUSE_COLOR
#undef PAUSE_STR
#undef PAUSE_W
#undef PAUSE_H
#undef PAUSE_X
#undef PAUSE_Y
}

/****************************************************************************
 *	demo_main
 ****************************************************************************/

int
demo_main()
{
	int result = -1;
	int x;
	int y;

	for(;;) {
		schedule();

		/* ʃNAB */
		memset(vbuff, 3, sizeof vbuff);

		/* X^[gHIH */
		if(joy & TRG_A) {
			sound_play(CH_PLAYER, SND_PSH2);
			result = 0;
			break;
		}
		if(joy & TRG_SELECT) {
			result = -1;
			break;
		}

		/* ՓxIB */
		if(joy & TRG_LF && difficulty > DIFFICULTY_NORMAL  ) {
			difficulty--;
			sound_play(CH_PLAYER, SND_PSH1);
		}
		if(joy & TRG_RI && difficulty < DIFFICULTY_VERYHARD) {
			difficulty++;
			sound_play(CH_PLAYER, SND_PSH1);
		}

		/* ^Cg\B */
		x = (DISP_X - 8 * 5) / 2;
		y = 16;
		render_string_framed(&render, x, y, "GUTSN", 0x81, 0x203);
		x += 8 * 3 + 4;
		y -= 2;
		render_string_framed(&render, x, y, "'", 0x81, 0x210);
		//
		x = (DISP_X - 10 * 6) / 2;
		y = 34;
		render_string_framed(&render, x, y, "Kc@@@", 0x80, 0x210);
		render_string_framed(&render, x, y, "@@@ǂ", 0x80, 0x203);

		/* XRA\B */
		score_disp();

		/* Փx\B */
		x = (DISP_X - 4 * 12) / 2;
		y = DISP_Y - 6 * 5;
		switch(difficulty) {
		case DIFFICULTY_NORMAL:
			render_string_framed(&render, x, y, "   NORMAL  >", 0x82, 0x203);
			break;
		case DIFFICULTY_HARD:
			render_string_framed(&render, x, y, "<   HARD   >", 0x82, 0x203);
			break;
		case DIFFICULTY_VERYHARD:
			render_string_framed(&render, x, y, "< VERYHARD  ", 0x82, 0x203);
			break;
		default:
			DIE();
		}

		/* vvg\B */
		x = (DISP_X - 4 * 8) / 2;
		y = DISP_Y - 6 * 3;
		render_string_framed(&render, x, y, " A START", 0x82, 0x203);
		y += 6;
		render_string_framed(&render, x, y, "SEL EXIT", 0x82, 0x203);
	}

	return result;
}

/****************************************************************************
 *	xe[u
 ****************************************************************************/

/* dbom(tel_rate) N/10000 łB */
const LEVEL level_table[] = {
	{ 1, 4, SEC(3.0),  0, SEC(15) },	// 0
	{ 2, 4, SEC(2.9), 50, SEC(15) },	// 1 <= NORMAL's 2nd level
	{ 3, 4, SEC(2.8), 50, SEC(15) },	// 2
	{ 4, 4, SEC(2.7), 50, SEC(15) },	// 3
	{ 2, 5, SEC(2.6), 50, SEC(15) },	// 4
	{ 3, 5, SEC(2.5), 50, SEC(15) },	// 5
	{ 4, 5, SEC(2.4), 50, SEC(15) },	// 6
	{ 2, 6, SEC(2.3), 50, SEC(15) },	// 7 <= HARD's 2nd level
	{ 3, 6, SEC(2.2), 50, SEC(15) },	// 8
	{ 4, 6, SEC(2.1), 50, SEC(15) },	// 9
	{ 2, 7, SEC(2.0), 50, SEC(15) },	//10
	{ 3, 7, SEC(1.9), 50, SEC(15) },	//11
	{ 4, 7, SEC(1.8), 50, SEC(15) },	//12
	{ 2, 8, SEC(1.7), 50, SEC(15) },	//13
	{ 3, 8, SEC(1.6), 50, SEC(15) },	//14
	{ 4, 8, SEC(1.5), 50, SEC(15) },	//15 <= VERYHARD's 2nd level
	{ 4, 8, SEC(1.4), 50, SEC(15) },	//16
	{ 4, 8, SEC(1.3), 50, SEC(15) },	//17
	{ 4, 8, SEC(1.2), 50, SEC(15) },	//18
	{ 4, 8, SEC(1.1), 50, SEC(15) },	//19
	{ 4, 8, SEC(1.0), 50, SEC(15) },	//20
	{ 4, 8, SEC(0.9), 50, SEC(15) },	//21
	{ 4, 8, SEC(0.8), 50, SEC(15) },	//22
	{ 4, 8, SEC(0.7), 50, SEC(15) },	//23
	{ 4, 8, SEC(0.6), 50, SEC(15) },	//24
	{ 4, 8, SEC(0.5), 50, SEC(15) },	//25
};
#define LEVEL_COUNT	(sizeof level_table / sizeof *level_table)

/* eՓx́Ax0̎̃x */
#define SECOND_LEVEL_NORMAL	 1
#define SECOND_LEVEL_HARD	 7
#define SECOND_LEVEL_VERYHARD	15

/****************************************************************************
 *	aۃp^[e[u
 ****************************************************************************/

const VIRUSPATTERN virus_pattern_table[/*aۂ̎*/] = {
	{ SPR_V000, SPR_V050 },	/* a#0 */
	{ SPR_V100, SPR_V150 },	/* a#1 */
	{ SPR_V200, SPR_V250 },	/* a#2 */
	{ SPR_V300, SPR_V350 },	/* a#3 */
	{ SPR_V400, SPR_V450 },	/* a#4(=db) */
};

/****************************************************************************
 *	new_virus
 ****************************************************************************/

/* ݂̃xɏ]āAVaۂ̎ނ_Ɍ肵܂B
 * [out]
 *	߂l		aۂ̎ށB(1`level_table[game.level].virus_kinds)
 */
int
new_virus()
{
	const LEVEL* level = &level_table[game.level];
	int f;
	int v;

	/* dboH */
	if(!game.tel_remain) {
		/* RND16()0`0xffffAtel_rate0`10000 */
		f = RND16(game.virus_seed) * 10000;
		if(f < level->tel_rate * 0xffff) {
			/* ܂Ƃ߂ĎOoB
			 * ̃[hɕ\͂܂B({AƂ)
			 */
			game.tel_remain = 3;
		}
	}
	if(game.tel_remain) {
		game.tel_remain--;
		return CELL_VIRUS_TEL;
	}

	/* aۏoB */
	v = RND16(game.virus_seed);
	return 1 + v % level->virus_kinds;
}

/****************************************************************************
 *	gen_virus
 ****************************************************************************/

/* ݂̃xɏ]āAtB[hŉsɕaۂ𐶐܂B
 */
void
gen_virus()
{
	const LEVEL* level = &level_table[game.level];
	int cols[FIELD_INNER_COLS];
	int col;
	int i;
	int j;
	int n;

	if(level->load_count < 1 || level->load_count > FIELD_INNER_COLS) DIE();

	/* ܂AŉsNAB */
	memset(&game.field[FIELD_ROW_MAX][0], 0, sizeof(CELL) * FIELD_COLS);

	/* o⌅ԍXgpӁB */
	for(i = 0; i < FIELD_INNER_COLS; i++) {
		cols[i] = FIELD_INNER_COL_MIN + i;
	}
	n = FIELD_INNER_COLS; /* Xgvf */

	/* o⌅ԍXg̒Ao_ɒoAaۂzuB */
	for(i = 0; i < level->load_count; i++) {
		j = RND16(game.virus_seed) % n;
		col = cols[j];
		n--;
		memmove(&cols[j], &cols[j + 1], sizeof *cols * (n - j));
		game.field[FIELD_ROW_MAX][col].virus = new_virus();
	}
}

/****************************************************************************
 *	update_player_row()
 ****************************************************************************/

/* vC[̌ʒuƂ̌̃Zɏ]āAvC[̍sʒuXV܂B
 */
void
update_player_row()
{
	int col;
	int row;
	CELL* cell;

	/* vC[Ȃ... */
	col = game.player_col;
	if(col >= FIELD_INNER_COL_MIN && col <= FIELD_INNER_COL_MAX) {
		/* vC[̌́Aɂaۂ́Aԏ̈ʒu𒲂ׂ܂B */
		for(row = FIELD_INNER_ROW_MIN; row <= FIELD_INNER_ROW_MAX; row++) {
			cell = &game.field[row][col];
			if(cell->virus) {
				/* vC[̈ʒúAaۂ̈̃ZƂ܂B
				 * aۂړ܂͗Ȃ΁Aaۂ͂܂̃ZɋƌȂ̂ŁA
				 * vC[̈ʒu͕aۂ̓̃ZƂ܂B
				 */
				switch(cell->state) {
				case CELL_STATE_MOVEDN:
				case CELL_STATE_FALL:
					game.player_row = row - 2;
					break;
				default:
					game.player_row = row - 1;
					break;
				}
				return; /* m */
			}
		}
	}

	/* vC[OA܂̓vC[̌ɕaۂȂ΁Anʂ̍Ƃ܂B */
	game.player_row = FIELD_INNER_ROW_MAX;
}

/****************************************************************************
 *	game_start
 ****************************************************************************/

void
game_start()
{
	int i;
	int x;
	int y;

	for(i = 0; i < 128; i += 32) {
		schedule();
		memset(vbuff, 3, sizeof vbuff);
		sprite_draw(-128 + i, 0, SPR_RDY1, 0);
		sprite_draw( 128 - i, 0, SPR_RDY2, 0);
	}

	for(i = 0; i < 64; i += 32) {
		schedule();
		sprite_draw(0, 0, SPR_RDY1, 0);
		sprite_draw(0, 0, SPR_RDY2, 0);
		x = 20 + i - 64;
		y = 57;
		render_rectangle_fill(&render, x, y, 60, 20, 3);
	}

	for(i = 0; i < SEC(2.0); i++) {
		schedule();
		sprite_draw(0, 0, SPR_RDY1, 0);
		sprite_draw(0, 0, SPR_RDY2, 0);
		x = 20;
		y = 57;
		render_rectangle_fill(&render, x, y, 60, 20, 3);
		if(i < SEC(1.25)) {
			if(i == 0) sound_play(CH_FIELD, SND_CER1);
			render_string_framed(&render, x + 3, y + 4, "qd`cx", 0x80, 0x203);
		} else {
			if(i == SEC(1.25)) sound_play(CH_FIELD, SND_CER8);
			render_string_framed(&render, x + 18, y + 1, "G O", 0x81, 0x203);
		}
	}

	for(i = 0; i < 64; i += 32) {
		schedule();
		sprite_draw(0, 0, SPR_RDY1, 0);
		sprite_draw(0, 0, SPR_RDY2, 0);
		x = 20 - i;
		y = 57;
		render_rectangle_fill(&render, x, y, 60, 20, 3);
	}
}

/* JčsAj[V̓Q[ɏd˂B */
void
start_disp()
{
	if(game.start_count < 128) {
		sprite_draw(-game.start_count, 0, SPR_RDY1, 0);
		sprite_draw( game.start_count, 0, SPR_RDY2, 0);
		game.start_count += 32;
	}
}

/****************************************************************************
 *	game_init
 ****************************************************************************/

void
game_init()
{
#define ROWS	3			/* Ԃł̏ȁos */
#define COLS	(level->load_count)	/* Ԃł    ȁo */
#define ROW1	(FIELD_INNER_ROW_MAX - (ROWS - 1))
#define ROW2	FIELD_INNER_ROW_MAX
#define COL1	((FIELD_COLS - COLS + 1) / 2)
#define COL2	((FIELD_COLS - COLS + 1) / 2 + COLS - 1)

	const LEVEL* level;
	int col;
	int row;
	CELL* cell;

	/* ܂NAB */
	memset(&game, 0, sizeof game);

	/* B@\B */
	if(pcePadGetDirect() & PAD_DN) {
		game.show_level = 1;
	}

	/* x擾B */
	level = &level_table[game.level];

	/* V[hB */
	game.virus_seed = pceTimerGetCount();

	/* x̊JnݒB */
	game.level_start_time = now;

	/* Ԃł̕a۔zuB */
	for(row = ROW1; row <= ROW2; row++) {
		for(col = COL1; col <= COL2; col++) {
			if((row == ROW1) && (!(col & 1) || (col == COL2))) continue; /* ŏs͂܂΂ */
			cell = &game.field[row][col];
			cell->virus = new_virus();
		}
	}
	gen_virus(); /* O̕aۂ́Aʏǂ萶 */

	/* vC[ʒuݒB */
	game.player_col = (FIELD_COLS - COLS) / 2 - 1;
	update_player_row();

	/* [h^C}B */
	game.load_timer = level->load_interval;

#undef ROWS
#undef COLS
#undef ROW1
#undef ROW2
#undef COL1
#undef COL2
}

/****************************************************************************
 *	game_main
 ****************************************************************************/

void
game_main()
{
	int state_count[CELL_STATE_COUNT];
	int i;
	int col;
	int row;
	const LEVEL* level;

	game.score = 0; /* READY`GO_ŕ\XRA[ɖ߂ */
	game_start();
	game_init();

	music_play(MUS_GAME);

/*==========================================================================*/
NORMAL: /* ʏ */
/*==========================================================================*/

	/* 1ANVł̏ŘANAB */
	game.erase_in_progress = 0;

	for(;;) {
		schedule();

		bg_disp();
		field_disp();
		player_disp();
		start_disp();
		score_disp();

		field_action_normal();
		player_action(1/*ANV\*/);
		update_player_row();

		/* ZԂ𐔂܂B */
		count_cell_state(state_count, 0/*{O*/);

		/* ړ̃Zꍇ̂݁AԑJډ\B */
		if(!state_count[CELL_STATE_MOVEDN] &&
		   !state_count[CELL_STATE_MOVELF] &&
		   !state_count[CELL_STATE_MOVERI]) {

			/* Jns܂B */
			field_check_fall();

			/* JnZ΁AԂ֑Jڂ܂B */
			count_cell_state(state_count, 0/*{O*/);
			if(state_count[CELL_STATE_FALL]) goto FALL;

			/* ŊJns܂B */
			field_check_erase();

			/* ŊJnZ΁AŏԂ֑Jڂ܂B */
			count_cell_state(state_count, 0/*{O*/);
			if(state_count[CELL_STATE_ERASE]) goto ERASE;

			/* ʏԂp܂B */
		}

		/* [h^C}JEg_EB */
		game.load_timer--;

		/* [hB */
		if(game.load_timer <= -LOAD_DELAY) {
			/* [h^C}[h܂B */
			game.load_timer = level_table[game.level].load_interval;
			game.force_load = 0; /* [htONA */

			/* aۂ[h܂B */
			for(col = FIELD_INNER_COL_MIN; col <= FIELD_INNER_COL_MAX; col++) {
				if(!game.field[FIELD_ROW_MAX][col].virus) continue;
				for(row = FIELD_ROW_MIN; row < FIELD_ROW_MAX; row++) {
					game.field[row][col] = game.field[row + 1][col];
				}
				clear_cell(&game.field[row][col]);
			}

			/* ŏsɕaۂAI[o[t[B */
			for(row = FIELD_ROW_MIN; row <= FIELD_INNER_ROW_MIN - 1; row++) {
				for(col = FIELD_INNER_COL_MIN; col <= FIELD_INNER_COL_MAX; col++) {
					if(game.field[row][col].virus) goto OVERFLOW;
				}
			}

			/* I[o[t[͕aۂ𐶐܂II */

			/* xAbvB */
			level = &level_table[game.level];
			if(now >= game.level_start_time + level->level_keep_time) {
				game.level_start_time = now;
				if(!game.level) {
					/* 0x̎́AՓxɂđIB */
					switch(difficulty) {
					case DIFFICULTY_NORMAL:
						game.level = SECOND_LEVEL_NORMAL;
						break;
					case DIFFICULTY_HARD:
						game.level = SECOND_LEVEL_HARD;
						break;
					case DIFFICULTY_VERYHARD:
						game.level = SECOND_LEVEL_VERYHARD;
						break;
					default:
						DIE();
					}
				} else {
					/* ȍ~́AЂƂÂ܂B */
					if(game.level < LEVEL_COUNT - 1) {
						game.level++;
					}
				}
			}

			/* Vaۂ𐶐܂B */
			gen_virus();

			sound_play(CH_FIELD, SND_CGEN);

			/* vC[̑̍ς\̂ŁAčXVB */
			update_player_row();
		}
	}
	DIE(); /* breakŔĂ͂܂ */

/*==========================================================================*/
FALL: /*  */
/*==========================================================================*/

	for(;;) {
		schedule();

		bg_disp();
		field_disp();
		player_disp();
		start_disp();
		score_disp();

		field_action_normal();
		field_action_fall();
		player_action(0/*ANVs*/);
		update_player_row();

		/* ZԂ𐔂܂B */
		count_cell_state(state_count, 0/*{O*/);

		/* ZȂAԑJډ\B */
		if(!state_count[CELL_STATE_FALL]) {

			/* ŊJns܂B */
			field_check_erase();

			/* ŊJnZ΁AŏԂ֑Jڂ܂B */
			count_cell_state(state_count, 0/*{O*/);
			if(state_count[CELL_STATE_ERASE]) goto ERASE;

			/* ʏԂ֑Jڂ܂B */
			goto NORMAL;
		}

		/* 1ANVł̏ŘAłȂ΁A[h^C}JEg_EB */
		if(!game.erase_in_progress) {
			game.load_timer--;
		}
	}
	DIE(); /* breakŔĂ͂܂ */

/*==========================================================================*/
ERASE: /*  */
/*==========================================================================*/

	/* 1ANVł̏ŘA}[NB */
	game.erase_in_progress = 1;

	/* Ȍňȍ~A0or1̃VbgōĂяŊJnAApƌȂB */
	if(game.shot_count <= 1) {
		game.erase_chain++;
	} else {
		game.erase_chain = 1; /* Ar؂ꂽ */
	}
	game.shot_count = 0; /* ̘Â߂ɁAVbg񐔂NA */

	/* _ŃZ~10~A */
	count_cell_state(state_count, 0/*{O*/);
	score_up(state_count[CELL_STATE_ERASE] * 10 * game.erase_chain);

	switch(game.erase_chain) {
	case 1:  sound_play(CH_FIELD, SND_CER1); break;
	case 2:  sound_play(CH_FIELD, SND_CER2); break;
	case 3:  sound_play(CH_FIELD, SND_CER3); break;
	case 4:  sound_play(CH_FIELD, SND_CER4); break;
	case 5:  sound_play(CH_FIELD, SND_CER5); break;
	case 6:  sound_play(CH_FIELD, SND_CER6); break;
	case 7:  sound_play(CH_FIELD, SND_CER7); break;
	default: sound_play(CH_FIELD, SND_CER8); break;
	}

	/* [hJnĂA[hJn_փZbgB */
	if(game.load_timer < 0) game.load_timer = 0;
	game.force_load = 0; /* ĊJ͋[h\sȂ */

	for(;;) {
		schedule();

		bg_disp();
		field_disp();
		player_disp();
		if(game.erase_chain >= 2) {
			chain_disp(game.erase_chain);
		}
		start_disp();
		score_disp();

		field_action_normal();
		field_action_erase();
		player_action(0/*ANVs*/);
		update_player_row();

		/* ZԂ𐔂܂B */
		count_cell_state(state_count, 0/*{O*/);

		/* ŃZȂAԑJډ\B */
		if(!state_count[CELL_STATE_ERASE]) {

			/* Jns܂B */
			field_check_fall();

			/* JnZ΁AԂ֑Jڂ܂B */
			count_cell_state(state_count, 0/*{O*/);
			if(state_count[CELL_STATE_FALL]) goto FALL;

			/* tB[hɒʏZ΁ASłłB */
			count_cell_state(state_count, 1/*̂*/);
			if(!state_count[0]) goto CLEANUP;

			/* ʏԂ֑Jڂ܂B */
			goto NORMAL;
		}
	}
	DIE(); /* breakŔĂ͂܂ */

/*==========================================================================*/
CLEANUP: /* N[Abv */
/*==========================================================================*/

	score_up(1000);

	sound_play(CH_FIELD, SND_CER8);

	/* vC[N[AbvԃZbgAbvB */
	set_player_state(PLAYER_STATE_CLEANUP);

	for(i = 0; i < SEC(1/*N[Abv\ԁA*/); i++) {
		schedule();

		bg_disp();
		field_disp();
		player_disp();
		cleanup_disp();
		start_disp();
		score_disp();

		field_action_normal();
		player_action(0/*ANVs*/);
		update_player_row();
	}

	/* vC[ʏԂɖ߂B */
	set_player_state(0);

	/* ʏԑJڌAɕaۂ[hB */
	game.load_timer = -LOAD_DELAY;

	/* ʏԂ֑Jڂ܂B */
	goto NORMAL;

/*==========================================================================*/
OVERFLOW: /* I[o[t[ */
/*==========================================================================*/

	music_stop();

	/* aەZbgAbvB */
	field_check_raise();

	/* vC[~XԃZbgAbvB */
	set_player_state(PLAYER_STATE_MISS);

	for(;;) {
		schedule();

		bg_disp();
		field_disp();
		player_disp();
		start_disp();
		score_disp();

		field_action_normal();
		field_action_raise();
		player_action(0/*ANVs*/);
		/* update_player_row()܂!! */

		/* ZԂ𐔂܂B */
		count_cell_state(state_count, 0/*{O*/);

		/* ZȂAԑJځB */
		if(!state_count[CELL_STATE_RAISE]) break;

		if(!(now % SEC(0.1))) {
			sound_play(CH_FIELD, SND_CRAI);
		}
	}

	/* vC[ԃZbgAbvB */
	set_player_state(PLAYER_STATE_FALL);

	i = 0;
	for(;;) {
		schedule();

		bg_disp();
		player_disp();
		start_disp();
		score_disp();

		if(game.player_substate) { /* JnĂAOVERFLOW\is */
			overflow_disp(i);
			i++;

			if(game.player_substate == 1 && game.player_counter == 0) {
				sound_play(CH_PLAYER, SND_PFAL);
			}
		}

		player_action(0/*ANVs*/);

		/* JnA莞ԌɏԑJځB */
		if(i >= SEC(3/**/)) break;
	}
}

/****************************************************************************
 *	set_player_state
 ****************************************************************************/

/* vC[Ԃݒ肵܂B
 * [in]
 *	player_state	vC[ԁB
 * [note]
 *	* vC[⏕ԁAJE^A⏕JE^̓[NA܂B
 */
void
set_player_state(int player_state)
{
	game.player_state = player_state;
	set_player_substate(0);
}

/****************************************************************************
 *	set_player_substate
 ****************************************************************************/

/* vC[⏕Ԃݒ肵܂B
 * [in]
 *	player_substate	vC[⏕ԁB
 * [note]
 *	* vC[Ԃ͕ω܂B
 *	* vC[JE^A⏕JE^̓[NA܂B
 */
void
set_player_substate(int player_substate)
{
	/* game.player_substate͈ێ܂B */
	game.player_substate = player_substate;
	game.player_counter = 0;
}

/****************************************************************************
 *	set_cell_state
 ****************************************************************************/

/* ZԂݒ肵܂B
 * [in]
 *	cell		ݒ肷ZB
 *	cell_state	ZԁB
 * [note]
 *	* Z⏕ԁAJE^A⏕JE^̓[NA܂B
 */
void
set_cell_state(CELL* cell, int cell_state)
{
	cell->state = cell_state;
	set_cell_substate(cell, 0);
}

/****************************************************************************
 *	set_cell_substate
 ****************************************************************************/

/* Z⏕Ԃݒ肵܂B
 * [in]
 *	cell		ݒ肷ZB
 *	cell_substate	Z⏕ԁB
 * [note]
 *	* ZԂ͕ω܂B
 *	* ZJE^A⏕JE^̓[NA܂B
 */
void
set_cell_substate(CELL* cell, int cell_substate)
{
	/* cell->substate͈ێ܂B */
	cell->substate = cell_substate;
	cell->counter = 0;
}

/****************************************************************************
 *	clear_cell
 ****************************************************************************/

/* ZɃNA܂B
 * [in]
 *	cell		NAZB
 */
void
clear_cell(CELL* cell)
{
	memset(cell, 0, sizeof(CELL));
}

/****************************************************************************
 *	count_cell_state
 ****************************************************************************/

/* tB[hSor̃Z𑖍āAeZԂ̐𐔂܂B
 * [in]
 *	state_count	ʂ󂯎zւ̃|C^B
 *	inner_only	𐔂ꍇ1w肵ĂB
 *			O܂߂Đꍇ0w肵ĂB
 * [note]
 *	* ʏ(state=0)̐state_count[0]ɃJEg܂B
 *	* aۂȂZ͂ǂɂJEg܂B
 */
void
count_cell_state(int state_count[/*CELL_STATE_COUNT*/], int inner_only)
{
	int col_min;
	int col_max;
	int row_min;
	int row_max;
	int col;
	int row;
	CELL* cell;

	/* ܂NA܂B */
	memset(state_count, 0, sizeof(int) * CELL_STATE_COUNT);

	/* ͈͂I܂B */
	if(inner_only) {
		/* ̂ */
		col_min = FIELD_INNER_COL_MIN;
		col_max = FIELD_INNER_COL_MAX;
		row_min = FIELD_INNER_ROW_MIN;
		row_max = FIELD_INNER_ROW_MAX;
	} else {
		/* O܂ */
		col_min = FIELD_COL_MIN;
		col_max = FIELD_COL_MAX;
		row_min = FIELD_ROW_MIN;
		row_max = FIELD_ROW_MAX;
	}

	/* w͈͂𑖍... */
	for(row = row_min; row <= row_max; row++) {
		for(col = col_min; col <= col_max; col++) {
			cell = &game.field[row][col];
			if(cell->virus) { /* aۂZJEgΏۂƂ܂ */
				if(cell->state < 0 || cell->state > CELL_STATE_COUNT - 1) DIE(); /* Ô */
				state_count[cell->state]++; /* ԃJEgAbv */
			}
		}
	}
}

/****************************************************************************
 *	bg_disp
 ****************************************************************************/

/* wi\܂B
 */
void
bg_disp()
{
	sprite_draw(0, 0, SPR_BG, 0);
}

/****************************************************************************
 *	player_disp
 ****************************************************************************/

/* vC[\܂B
 * [note]
 *	* ʏ́AvC[Z̏ɕ\̂ŁA
 *		bg_disp()
 *		field_disp()
 *		player_disp()
 *	  ̏ɌĂяoĂB
 *	* ~X̂݁AZvC[̏ɕ\̂ŁA
 *		bg_disp()
 *		player_disp()
 *		field_disp()
 *	  ̏ɌĂяoĂB
 */
void
player_disp()
{
	int x;
	int y;
	int sprno;

	x = FIELD_X0 + CELL_W * game.player_col;
	y = FIELD_Y0 + CELL_H * game.player_row;
	switch(game.player_state) {

	/*** ʏ ***/
	case 0:
		sprno = SPR_N000 + (game.player_counter / 2 & 3);
		sprite_draw(x, y, sprno, 0);
		break;

	/*** ˂ ***/
	case PLAYER_STATE_SHOTDN:
		if(game.player_counter < 2 * 3) {
			sprno = SPR_N010 + game.player_counter / 2;
		} else {
			sprno = SPR_N000;
		}
		sprite_draw(x, y, sprno, 0);
		break;

	/*** ˂ ***/
	case PLAYER_STATE_SHOTLF:
		if(game.player_counter < 2 * 3) {
			sprno = SPR_N020 + game.player_counter / 2;
		} else {
			sprno = SPR_N000;
		}
		sprite_draw(x, y, sprno, 0);
		break;

	/*** E˂ ***/
	case PLAYER_STATE_SHOTRI:
		if(game.player_counter < 2 * 3) {
			sprno = SPR_N030 + game.player_counter / 2;
		} else {
			sprno = SPR_N000;
		}
		sprite_draw(x, y, sprno, 0);
		break;

	/*** N[Abv ***/
	case PLAYER_STATE_CLEANUP:
		sprno = SPR_N070 + (game.player_counter / 2 & 3);
		sprite_draw(x, y, sprno, 0);
		break;

	/*** ~X ***/
	case PLAYER_STATE_MISS:
		sprno = SPR_N040 + (game.player_counter / 2 & 3);
		sprite_draw(x, y, sprno, 0);
		break;

	/***  ***/
	case PLAYER_STATE_FALL:
		switch(game.player_substate) {
		case 0: sprno = SPR_N050 + (game.player_counter / 2 & 3); break; /* O[V */
		case 1: sprno = SPR_N060;                                 break; /* #0 */
		case 2: sprno = SPR_N061; y += game.player_counter;       break; /* #1 */
		default: DIE();
		}
		sprite_draw(x, y, sprno, 0);
		break;
	}
}

/****************************************************************************
 *	player_action
 ****************************************************************************/

/* vC[̏s܂B
 * [in]
 *	action_ok	[hA//E˂̔\Ȃ΁A1w肵ĂB
 *			sȂ΁A0w肵ĂB
 */
void
player_action(int action_ok)
{
	switch(game.player_state) {
	/*** ʏ ***/
	case 0:
		game.player_counter++;
		/* ړB */
		if((joy & TRG_LF) && (game.player_col > PLAYER_COL_MIN)) {
			game.player_col--;
			sound_play(CH_PLAYER, SND_PMOV);
			return;
		}
		/* EړB */
		if((joy & TRG_RI) && (game.player_col < PLAYER_COL_MAX)) {
			game.player_col++;
			sound_play(CH_PLAYER, SND_PMOV);
			return;
		}
		/* ˂B */
		if(joy & TRG_SELECT) {
			set_player_state(PLAYER_STATE_SHOTLF);
			sound_play(CH_PLAYER, SND_PSH1);
			return;
		}
		/* E˂B */
		if(joy & TRG_A) {
			set_player_state(PLAYER_STATE_SHOTRI);
			sound_play(CH_PLAYER, SND_PSH1);
			return;
		}
		/* ˂B */
		if(joy & TRG_B) {
			set_player_state(PLAYER_STATE_SHOTDN);
			sound_play(CH_PLAYER, SND_PSH1);
			return;
		}
		/* [hB */
		if(joy & TRG_UP) {
			if(action_ok) { /* ʏ펞̂ݔ\ */
				if(!game.force_load) { /* ɋ[hĂ疳 */
					game.force_load = 1; /* [hJn */
					game.load_timer = 0; /* Ɏ[hJnĂĂx0 (LOAD\Aj[V̂) */
					score_up(100);
				}
			}
			return;
		}
		return;

	/*** ˂A˂AE˂ ***/
	case PLAYER_STATE_SHOTDN:
	case PLAYER_STATE_SHOTLF:
	case PLAYER_STATE_SHOTRI:
		game.player_counter++;
		if(game.player_counter == 2 * 1) { /*  */
			if(action_ok) { /* ʏ펞̂ݔ\(Œ◎͋U) */
				process_shot();
			}
			return;
		}
		if(game.player_counter > 2 * 1) { /*  */
			/* U蔲[VLZEEړB */
			if((joy & TRG_LF) && (game.player_col > PLAYER_COL_MIN)) {
				set_player_state(0);
				game.player_col--;
				sound_play(CH_PLAYER, SND_PMOV);
				return;
			}
			/* U蔲[VLZEEEړB */
			if((joy & TRG_RI) && (game.player_col < PLAYER_COL_MAX)) {
				set_player_state(0);
				game.player_col++;
				sound_play(CH_PLAYER, SND_PMOV);
				return;
			}
		}
		if(game.player_counter >= 2 * 3) { /*  */
			set_player_state(0);
			return;
		}
		return;

	/*** N[Abv ***/
	case PLAYER_STATE_CLEANUP:
		game.player_counter++;
		/* N[Abvʏ̏ԑJڂ́AOs܂B */
		break;

	/*** ~X ***/
	case PLAYER_STATE_MISS:
		game.player_counter++;
		/* ~X̏ԑJڂ́AOs܂B */
		return;

	/***  ***/
	case PLAYER_STATE_FALL:
		switch(game.player_substate) {
		case 0: /* O[V */
			game.player_counter++;
			if(game.player_counter >= SEC(0.5/**/)) {
				set_player_substate(1);
			}
			return;
		case 1: /* #1 */
			game.player_counter++;
			if(game.player_counter >= 2) {
				set_player_substate(2);
			}
			return;
		case 2: /* #2 */
			if(game.player_counter < DISP_Y + DISP_Y / 2) { /* mɉʊOƂȂItZbg */
				game.player_counter += CELL_H; /* x */
			}
			/* ̎̏ԑJڂ͂܂B */
			return;
		default:
			DIE();
		}
	}
}

/****************************************************************************
 *	process_shot
 ****************************************************************************/

/* ˂A˂AE˂̏sTu[`łB
 * [note]
 *	* player_action()痘p܂B
 */
void
process_shot(int player_state)
{
	int cell_state;
	int vcol;
	int vrow;
	int col1;
	int col2;
	int row1;
	int row2;
	CELL* cell1;
	CELL* cell2;

	/* ƃZԂI܂B */
	switch(game.player_state) {
	case PLAYER_STATE_SHOTDN: cell_state = CELL_STATE_MOVEDN; vcol =  0; vrow = 1; break;
	case PLAYER_STATE_SHOTLF: cell_state = CELL_STATE_MOVELF; vcol = -1; vrow = 0; break;
	case PLAYER_STATE_SHOTRI: cell_state = CELL_STATE_MOVERI; vcol =  1; vrow = 0; break;
	default: DIE();
	}

	/* OZ˂ĂN܂B */
	col1 = game.player_col + vcol;
	row1 = game.player_row + vrow;
	if(col1 < FIELD_INNER_COL_MIN || col1 > FIELD_INNER_COL_MAX) return;
	if(row1 < FIELD_INNER_ROW_MIN || row1 > FIELD_INNER_ROW_MAX) return;

	/* ZʏԂłȂZ˂ĂN܂B */
	cell1 = &game.field[row1][col1];
	if(!cell1->virus) return;
	if(cell1->state) return;

	/* ˂̋󔒃ZA܂͏OŒ[̃Z擾܂B */
	col2 = col1;
	row2 = row1;
	while(col2 > FIELD_COL_MIN && col2 < FIELD_COL_MAX &&
	      row2 > FIELD_ROW_MIN && row2 < FIELD_ROW_MAX) {
		cell2 = &game.field[row2][col2];
		if(!cell2->virus) break;
		col2 += vcol;
		row2 += vrow;
	}

	/* Z̕т炵āAړԂݒ肵܂B */
	while(col1 != col2 || row1 != row2) {
		cell1 = &game.field[row2       ][col2       ];
		cell2 = &game.field[row2 - vrow][col2 - vcol];
		*cell1 = *cell2;
		clear_cell(cell2);
		set_cell_state(cell1, cell_state);
		col2 -= vcol;
		row2 -= vrow;
	}
	cell1->substate = 1; /* ŌɃZbgAbvZ(=˂Z)͕ʕ\B */

	/* Vbg񐔂JEgAbv܂B */
	game.shot_count++;

	sound_play(CH_PLAYER, SND_PSH2);

	return;
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

/* AO܂߂tB[hŜ̃Z\܂B
 * [in]
 *	action_ok	[hA//E˂̔\Ȃ΁A1w肵ĂB
 *			sȂ΁A0w肵ĂB
 * [note]
 *	* wi͕\܂B
 *	  bg_disp()ĂŁAwi\ĂĂB
 */
void
field_disp()
{
	int tmp;
	int col;
	int row;
	int x;
	int y;
	int sprno;
	CELL* cell;
	const VIRUSPATTERN* pattern;

	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->virus) continue; /* Z͔΂܂ */

			pattern = &virus_pattern_table[cell->virus - 1];
			x = FIELD_X0 + CELL_W * col;
			y = FIELD_Y0 + CELL_H * row;
			switch(cell->state) {

			/*** ʏAŔ҂ ***/
			case 0:
			case CELL_STATE_CHECK:
				sprno = pattern->normal;
				switch(cell->substate) {
				case 0: /* ʏ */
					sprite_draw(x, y, sprno, 0);
					break;
				case 1: /* ] */
					sprno += cell->counter;
					sprite_draw(x, y, sprno, 0);
					break;
				case 2: /* U */
					sprno += 26;
					switch(cell->counter & 7) {
					case 1: y--; break;
					case 3: x--; break;
					case 5: y--; break;
					case 7: x++; break;
					}
					sprite_draw(x, y, sprno, 0);
					break;
				default:
					DIE();
				}
				break;

			/*** ړ ***/
			case CELL_STATE_MOVEDN:
				switch(cell->substate) {
				case 0: sprno = pattern->normal + 26; break; /* ꂽa */
				case 1: sprno = pattern->action +  3; break; /* ˂ꂽa */
				default: DIE();
				}
				y = y - CELL_H + cell->counter;
				sprite_draw(x, y, sprno, 0);
				break;

			/*** ړ ***/
			case CELL_STATE_MOVELF:
				switch(cell->substate) {
				case 0: sprno = pattern->normal + 26; break; /* ꂽa */
				case 1: sprno = pattern->action +  3; break; /* ˂ꂽa */
				default: DIE();
				}
				x = x + CELL_W - cell->counter;
				sprite_draw(x, y, sprno, 0);
				break;

			/*** Eړ ***/
			case CELL_STATE_MOVERI:
				switch(cell->substate) {
				case 0: sprno = pattern->normal + 26; break; /* ꂽa */
				case 1: sprno = pattern->action +  3; break; /* ˂ꂽa */
				default: DIE();
				}
				x = x - CELL_W + cell->counter;
				sprite_draw(x, y, sprno, 0);
				break;

			/***  ***/
			case CELL_STATE_FALL:
				sprno = pattern->normal;
				if(cell->counter < CELL_H) {
					y = y - CELL_H + cell->counter;
				}
				sprite_draw(x, y, sprno, 0);
				break;

			/***  ***/
			case CELL_STATE_ERASE:
				switch(cell->substate) {
				case 0: /* _ */
					sprno = pattern->action + (cell->counter & 1);
					sprite_draw(x, y, sprno, 0);
					break;
				case 1: /* _ŁA */
					if(cell->counter < 2) { /* _ */
						sprno = (pattern->action + 2) + cell->counter;
						sprite_draw(x, y, sprno, 0);
					} else if(cell->counter < 2 + 4) {
						sprno = SPR_E050 + (cell->counter - 2);
						sprite_draw(x, y, sprno, 0);
					} else {
						/* \Ȃ */
					}
					break;
				default:
					DIE();
				}
				break;

			/***  ***/
			case CELL_STATE_RAISE:
				sprno = pattern->normal;
				if(now / 2 & 1) {
					sprno += 26;
				}
				y -= cell->counter; /* ړE͈ړ̃ZłAゾ͈ړ̃Zł */
				sprite_draw(x, y, sprno, 0);
				break;

			default:
				DIE();
			}
		}
	}

	/* o\B
	 * load_timer==0́AŒ̏ô߂ɁA\Ƃ܂B
	 * load_timer==-LOAD_DELAÝAN[Abvʏւ̑Jڎ̂߂ɁA\Ƃ܂B
	 */
	if(game.load_timer < 0 && game.load_timer > -LOAD_DELAY) {
		for(col = FIELD_INNER_COL_MIN; col <= FIELD_INNER_COL_MAX; col++) {
			if(!game.field[FIELD_ROW_MAX][col].virus) continue;
			x = FIELD_X0 + CELL_W * col;
			y = FIELD_Y0 + CELL_H * FIELD_INNER_ROW_MAX;
			switch(game.load_timer & 3) {
			case 1: y++; break;
			case 3: y--; break;
			}
			sprno = SPR_A000;
			sprite_draw(x, y, sprno, 0);
		}

		/* [h\B */
		if(game.force_load) {
			sprno = SPR_LOAD;
			x = FIELD_X0 + CELL_W * FIELD_INNER_COL_MIN;
			y = DISP_Y - 16;
			tmp = -game.load_timer * 4;
			if(tmp < (16 + 4)) {
				y = y + 16 - tmp;
			} else if(tmp < (16 + 4 + 4)) {
				y = y - (16 + 4 + 4) + tmp;
			}
			if(-game.load_timer * 3 <= 16) {
				y = y + 16 - -game.load_timer * 3;
			}
			sprite_draw(x, y, sprno, 0);
		}
	}
}

/****************************************************************************
 *	field_action_normal
 ****************************************************************************/

/* tB[hŜ̒ʏ폈s܂B(ʏAړAړAEړ)
 */
void
field_action_normal()
{
	int col;
	int row;
	int col1;
	int col2;
	int virus;
	int substate;
	CELL* cell;

	for(row = FIELD_ROW_MIN; row <= FIELD_ROW_MAX; row++) {
		for(col = FIELD_COL_MIN; col <= FIELD_COL_MAX; col++) {
			cell = &game.field[row][col];
			if(!cell->virus) continue; /* Z͔΂܂ */
			switch(cell->state) {

			/*** ʏ ***/
			case 0:
				switch(cell->substate) {
				case 1: /* ] */
					cell->counter++;
					if(cell->counter >= 26) {
						set_cell_substate(cell, 0);
					}
					break;
				case 2: /* U */
					cell->counter++;
					if(cell->counter >= SEC(1)) { /* U  */
						set_cell_substate(cell, 0);
					}
					break;
				}
				break;

			/*** ړ ***/
			case CELL_STATE_MOVEDN:
				cell->counter += CELL_H / 2; /* ړx */
				if(cell->counter >= CELL_H) {
					if(row <= FIELD_INNER_ROW_MAX) {
						/* tB[hȂ΁A`FbN҂B */
						set_cell_state(cell, CELL_STATE_CHECK);
					} else {
						/* [h҂sȂ΁AʏԃwڍsB */
						set_cell_state(cell, 0);
					}
				}
				break;

			/*** ړAEړ ***/
			case CELL_STATE_MOVELF:
			case CELL_STATE_MOVERI:
				cell->counter += CELL_W / 2; /* ړx */
				if(col >= FIELD_INNER_COL_MIN && col <= FIELD_INNER_COL_MAX) {
					/* tB[hȂ΁AZړĒ~A`FbN҂B */
					if(cell->counter >= CELL_W) {
						set_cell_state(cell, CELL_STATE_CHECK);
					}
				} else {
					/* tB[hOȂ΁AZړďŁB */
					if(cell->counter >= CELL_W * 2) {
						clear_cell(cell);
					}
				}
				break;
			}
		}
	}

	/*** ʏZ̃ANVJnB ***/
	{
		/* tB[hŜA̋N__ɑIт܂B */
		col = RND16(game.generic_seed) % FIELD_COLS;
		row = RND16(game.generic_seed) % FIELD_ROWS;

		/* ̋N_ʏԂ̕aۂłȂ΁AANVJn܂B */
		cell = &game.field[row][col];
		virus = cell->virus;
		if(!virus) goto NO_ACTION;
		if(cell->state || cell->substate) goto NO_ACTION;

		/* F̕т̍[܂ő܂B */
		col1 = col;
		for(;;) {
			col1--; /* ň֐i߂Ă݂ */
			if(col1 < FIELD_COL_MIN) break; /* tB[hOȂ甲 */
			cell = &game.field[row][col1];
			if(cell->virus != virus) break; /* orF甲 */
			/* Fт̒ɒʏԂłȂaۂAANVJn܂B */
			if(cell->state || cell->substate) goto NO_ACTION;
		}
		col1++; /* ֐i݂Ă̂Ŗ߂ */

		/* F̕т̉E[܂ő܂B */
		col2 = col;
		for(;;) {
			col2++; /* ňE֐i߂Ă݂ */
			if(col2 > FIELD_COL_MAX) break; /* tB[hOȂ甲 */
			cell = &game.field[row][col2];
			if(cell->virus != virus) break; /* orF甲 */
			/* Fт̒ɒʏԂłȂaۂAANVJn܂B */
			if(cell->state || cell->substate) goto NO_ACTION;
		}
		col2--; /* E֐i݂Ă̂Ŗ߂ */

		/* ANV̎ނIB */
		substate = RND16(game.generic_seed) & 1 ? 1/*]*/ : 2/*U*/;

		/* ȏ̕тłȂ΁AANVJn܂B
		 * Adb̐U͒PƂłJn܂B
		 */
		if(col1 == col2) {
			if(virus == CELL_VIRUS_TEL && substate == 2/*U*/) {
				/** no job **/
			} else {
				goto NO_ACTION;
			}
		}

		///* Ɠdb肷̂ŁA1/2炢ɗ}B */
		//if(virus == CELL_VIRUS_TEL && substate == 2) {
		//	if(RND16(game.generic_seed) & 1) goto NO_ACTION;
		//}
		//łȂ̂ł߂B

		/* FEʏԂ̕aەт̃ANVJnB */
		for(col = col1; col <= col2; col++) {
			cell = &game.field[row][col];
			/*{{ASSERT*/
			if(cell->virus != virus) DIE();
			if(cell->state || cell->substate) DIE();
			/*}}ASSERT*/
			set_cell_substate(cell, substate);
			/* dbȔꍇ͌ʉX^[gB */
			if(virus == CELL_VIRUS_TEL && substate == 2) {
				sound_play(CH_TEL, SND_CTEL);
			}
		}
NO_ACTION:
	}
}

/****************************************************************************
 *	field_check_fall
 ****************************************************************************/

/* tB[h̗Jns܂B
 */
void
field_check_fall()
{
	int col;
	int row;
	CELL* cell1;
	CELL* cell2;

	/* JnɈ̃Zֈړ̂ŁȀőBK{!!
	 * tB[hŉs͗JnȂ̂ŁA̍s瑖B
	 */
	for(row = FIELD_INNER_ROW_MAX - 1; row >= FIELD_INNER_ROW_MIN; row--) {
		for(col = FIELD_INNER_COL_MIN; col <= FIELD_INNER_COL_MAX; col++) {
			cell1 = &game.field[row][col];
			if(!cell1->virus) continue; /* Z͔΂܂ */
			switch(cell1->state) {

			/*** ʏAŔ҂ ***/
			case 0:
			case CELL_STATE_CHECK:
				cell2 = cell1 + FIELD_COLS; /* ̃Z */
				if(!cell2->virus) {
					/* ZȂ΁AJnB */
					*cell2 = *cell1;
					clear_cell(cell1);
					set_cell_state(cell2, CELL_STATE_FALL);
					break;
				}
				break;

			default:
				/* ʏ܂͏Ŕ҂ȊÕZ݂ԂŁÅ֐Ăł͂܂B
				 * ړAAŒ̃Z݂ꍇ́ȀĂ炱̊֐ĂłB
				 */
				DIE();
			}
		}
	}
}

/****************************************************************************
 *	field_action_fall
 ****************************************************************************/

/* tB[h̗s܂B
 */
void
field_action_fall()
{
	int col;
	int row;
	CELL* cell1;
	CELL* cell2;

	/* Aɂ񒅒nĂ܂Ȃ悤ȀőBK{!! */
	for(row = FIELD_INNER_ROW_MAX; row >= FIELD_INNER_ROW_MIN; row--) {
		for(col = FIELD_INNER_COL_MIN; col <= FIELD_INNER_COL_MAX; col++) {
			cell1 = &game.field[row][col];
			if(!cell1->virus) continue; /* Z͔΂܂ */
			switch(cell1->state) {

			/***  ***/
			case CELL_STATE_FALL:
				cell1->counter += CELL_H / 2; /* x */
				if(cell1->counter >= CELL_H) {
					cell2 = cell1 + FIELD_COLS; /* ̃Z */
					if(row == FIELD_INNER_ROW_MAX || cell2->virus) {
						/* tB[hŉsAɕaۂ΁Ană`FbN҂B */
						set_cell_state(cell1, CELL_STATE_CHECK);
					} else {
						/* tB[hŉsłȂAZȂ΁AֈڂėpB */
						*cell2 = *cell1;
						clear_cell(cell1);
						cell2->counter -= CELL_H;
					}
				}
				break;
			}
		}
	}
}

/****************************************************************************
 *	field_check_erase
 ****************************************************************************/

/* tB[h̏ŊJns܂B
 */
void
field_check_erase()
{
	int col;
	int row;
	int count;
	int check;
	CELL* cell1;
	CELL* cell2;

	/* ŊJns܂B */
	for(row = FIELD_INNER_ROW_MIN; row <= FIELD_INNER_ROW_MAX; row++) {
		for(col = FIELD_INNER_COL_MIN; col <= FIELD_INNER_COL_MAX; col++) {
			cell1 = &game.field[row][col];
			if(!cell1->virus) continue; /* Z͔΂܂ */

			/* ̕aۂ̕т𐔂܂B */
			check = 0; /* т̒ɁAŔ҂̕aۂ܂ł1 */
			count = 0;
			cell2 = cell1;
			while(col + count <= FIELD_INNER_ROW_MAX) {
				if(cell2->virus != cell1->virus) break;
				if(cell2->state == CELL_STATE_CHECK) check = 1;
				count++;
				cell2++;
			}

			/* ̕aۂOȏłāA̒ɏŔ҂̕aۂ܂łAŊJnB */
			if(count >= 3 && check) {
				cell2 = cell1;
				while(count) {
					set_cell_state(cell2, CELL_STATE_ERASE);
					count--;
					cell2++;
					col++; /* ŊJnZ͂`FbNȂ */
				}
			}
		}
	}

	/* Ŕ҂ŏŊJnȂŹAŔ҂ԂNA܂B */
	for(row = FIELD_INNER_ROW_MIN; row <= FIELD_INNER_ROW_MAX; row++) {
		for(col = FIELD_INNER_COL_MIN; col <= FIELD_INNER_COL_MAX; col++) {
			cell1 = &game.field[row][col];
			if(!cell1->virus) continue; /* Z͔΂܂ */
			if(cell1->state == CELL_STATE_CHECK) set_cell_state(cell1, 0);
		}
	}
}

/****************************************************************************
 *	field_action_erase
 ****************************************************************************/

/* tB[h̏ŏs܂B
 */
void
field_action_erase()
{
	int col;
	int row;
	CELL* cell;

	for(row = FIELD_INNER_ROW_MIN; row <= FIELD_INNER_ROW_MAX; row++) {
		for(col = FIELD_INNER_COL_MIN; col <= FIELD_INNER_COL_MAX; col++) {
			cell = &game.field[row][col];
			if(!cell->virus) continue; /* Z͔΂܂ */
			switch(cell->state) {

			/***  ***/
			case CELL_STATE_ERASE:
				switch(cell->substate) {
				case 0: /* _ */
					cell->counter++;
					if(cell->counter >= SEC(0.5)) { /* _Ŏ  */
						set_cell_substate(cell, 1);
					}
					break;
				case 1: /* _ŁA */
					cell->counter++;
					if(cell->counter >= 2 + 4) {
						clear_cell(cell);
					}
					break;
				default:
					DIE();
				}
				break;
			}
		}
	}
}

/****************************************************************************
 *	field_check_raise
 ****************************************************************************/

/* tB[h̕Jns܂B
 */
void
field_check_raise()
{
	int col;
	int row;
	CELL* cell;

	/* tB[hɎcĂSĂ̕aۂɁAJn҂}[N܂B */
	for(row = FIELD_ROW_MIN; row <= FIELD_ROW_MAX; row++) {
		for(col = FIELD_COL_MIN; col <= FIELD_COL_MAX; col++) {
			cell = &game.field[row][col];
			if(!cell->virus) continue; /* Z͔΂܂ */
			set_cell_state(cell, CELL_STATE_RAISE);
		}
	}
}

/****************************************************************************
 *	field_action_raise
 ****************************************************************************/

/* tB[h̕㏈s܂B
 */
void
field_action_raise()
{
	int col;
	int row;
	CELL* cell1;
	CELL* cell2;

	for(row = FIELD_ROW_MIN; row <= FIELD_ROW_MAX; row++) {
		for(col = FIELD_COL_MIN; col <= FIELD_COL_MAX; col++) {
			cell1 = &game.field[row][col];
			if(!cell1->virus) continue; /* Z͔΂܂ */
			switch(cell1->state) {

			/***  ***/
			case CELL_STATE_RAISE:
				if(row == FIELD_ROW_MIN) { /* ŏs */
					cell1->counter += CELL_H / 4; /* 㑬x */
					if(cell1->counter >= CELL_H) {
						clear_cell(cell1);
					}
				} else { /* ŏsȊO */
					cell2 = &game.field[row - 1][col];
					if(!cell2->virus) { /* ̃Z󂢂畂Jn */
						cell1->counter += CELL_H / 4; /* 㑬x */
						if(cell1->counter >= CELL_H) {
							*cell2 = *cell1;
							clear_cell(cell1);
							cell2->counter -= CELL_H;
						}
					}
				}
			}
		}
	}
}

/****************************************************************************
 *	chain_disp
 ****************************************************************************/

/* CHAINbZ[W\܂B
 * [in]
 *	chain		AB(2`)
 */
void
chain_disp(int chain)
{
	const char* msg = "bg`hm";
	//
	char buf[2 + 1];
	int len;
	int x;
	int y;

	len = strlen(msg);
	x = (DISP_X - 5 * len) / 2 - 1/**/;
	y = (DISP_Y - 10) / 2 - 1/**/;
	render_string_framed(&render, x, y, msg, 0x80, 0x203);

	if(chain <  0) DIE();
	if(chain > 99) chain = 99;
	len = sprintf(buf, "%d", chain);
	x = (DISP_X - 8 * len) / 2 - 1/**/;
	y = (DISP_Y - 10) / 2 - 1/**/ - 16;
	render_string_framed(&render, x, y, buf, 0x81, 0x203);
}

/****************************************************************************
 *	cleanup_disp
 ****************************************************************************/

/* CLEANUPbZ[W\܂B
 */
void
cleanup_disp()
{
	const char* msg = "bkd`mto";
	const int len = strlen(msg);
	//
	int x;
	int y;

	x = (DISP_X - 5 * len) / 2 - 1/**/;
	y = (DISP_Y - 10) / 2 - 1/**/;
	render_string_framed(&render, x, y, msg, 0x80, 0x203);
}

/****************************************************************************
 *	overflow_disp
 ****************************************************************************/

/* OVERFLOWbZ[W\܂B
 * [in]
 *	count		Aj[VJE^B
 *			1ÂȂÅ֐ĂяoĂB
 */
void
overflow_disp(int count)
{
#define TOTAL_STEP	SEC(0.33)	/* ԁA */
#define TOTAL_ROT	PI		/* ]pxA */
#define TOTAL_MUL	2		/* Ԋu{A */

	const char* msg = "nudqeknv"; /* bZ[WAύXBSđSpƂ邱 */
	const int len = strlen(msg) / 2/*Sp*/;
	//
	int i;
	fixed d;
	fixed r;
	fixed s;
	fixed c;
	fixed w;
	fixed x0;
	fixed y0;
	fixed x1;
	fixed y1;
	int x;
	int y;

	/* JE^𑝉ɕϊB */
	count = count < TOTAL_STEP ? TOTAL_STEP - count : 0;

	/* oߎԁԂvZB */
	d = fdiv(fild(count), fild(TOTAL_STEP));

	/* ]pxp[^vZB */
	r = fchs(fmul(d, TOTAL_ROT));
	s = fsin(r);
	c = fcos(r);

	/* ԊuvZB */
	w = fiadd(fimul(d, (TOTAL_MUL - 1) * 10), 10);

	/* ]lȂꍇ̍ŏ̒̕SʒuB(ʒ) */
	x0 = fchs(fidiv(fimul(w, len - 1), 2));
	y0 = 0;
	for(i = 0; i < len; i++) {
		/* ]l̒SʒuB(ʒ) */
		x1 = fsub(fmul(x0, c), fmul(y0, s));
		y1 = fadd(fmul(x0, s), fmul(y0, c));

		/* ̍ʒuB */
		x = (DISP_X / 2 - 1/**/) + fist(x1) - 5;
		y = (DISP_Y / 2 - 1/**/) + fist(y1) - 5;

		/* ꕶ`B */
		render_printf_framed(&render, x, y, 0x80, 0x203, "%2.2s", msg + i * 2);

		/* ]lȂꍇ̒̕Sʒui߂܂B */
		x0 = fadd(x0, w);
	}

#undef TOTAL_STEP
#undef TOTAL_ROT
#undef TOTAL_MUL
}

/****************************************************************************
 *	score_disp
 ****************************************************************************/

/* XRA\܂B
 */
void
score_disp()
{
	if(now % SEC(1) < SEC(0.8)) {
		render_printf_framed(&render, DISP_X - 4 * 10 - 1, 0, 0x82, 0x103,  "HI:%07d", hiscore   );
		render_printf_framed(&render,                   0, 0, 0x82, 0x103, "1UP:%07d", game.score);
		if(game.show_level) {
			render_printf_framed(&render, (DISP_X - 4 * 6) / 2 - 1, 0, 0x82, 0x103, "LEV:%02d", game.level);
		}
	}
}

/****************************************************************************
 *	score_up
 ****************************************************************************/

/* XRAZ܂B
 */
void
score_up(int pts)
{
	game.score += pts;
	if(game.score > MAX_SCORE) game.score = MAX_SCORE;
	if(game.score > hiscore) hiscore = game.score;
}
